/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package Anonymous;
import Server.ChatMessage;
import java.io.*;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;

public class Anonymous  
{

	// for I/O
	private static ObjectInputStream sInput;		// to read from the socket
	private static ObjectOutputStream sOutput;		// to write on the socket
	//private Socket socket;
	private SSLSocket socket;
	// if I use a GUI or not
	private static AnonymousGUI cg;
	// the server, the port and the username
	private String server, username;
	private int port;
	Anonymous(String server, int port, String username, AnonymousGUI cg) 
	{
		this.server = server;
		this.port = port;
		this.username = username;
		// save if we are in GUI mode or not
		Anonymous.cg = cg;
	}
	/*
	 * To start the dialog
	 */
	public boolean start() 
	{
		// try to connect to the server
		try 
		{
			System.setProperty("javax.net.ssl.trustStore", "cacerts.jks");
			System.setProperty("javax.net.ssl.trustStorePassword","test123");
			SSLSocketFactory sslsocketfactory = (SSLSocketFactory)SSLSocketFactory.getDefault();
			socket = (SSLSocket)sslsocketfactory.createSocket(server,port);
		} 
		// Fails connecting to the server
		catch(Exception ec) 
		{
			cg.append(null,"Error connectiong to server:" + ec);
			return false;
		}
		String msg = "Connection accepted " + socket.getInetAddress() + ":" + socket.getPort();
		cg.append("",msg);
		/* Creating both Data Streams */
		try
		{
			sInput  = new ObjectInputStream(socket.getInputStream());
			sOutput = new ObjectOutputStream(socket.getOutputStream());
		}
		catch (IOException eIO) 
		{
			cg.append("","Exception creating new Input/output Streams: " + eIO);
			return false;
		}
		// creates the Thread to listen from the server 
		new anonListener().start();
		// Send our username to the server this is the only message that we
		// will send as a String. All other messages will be ChatMessage objects
		try
		{
			sOutput.writeObject(username); //write the username
			sOutput.writeObject(null); //write the password
		}
		catch (IOException eIO) 
		{
			cg.append("","Exception doing login : " + eIO);
			disconnect();
			return false;
		}
		// success we inform the caller that it worked\
		return true;
	}
	void sendMessage(ChatMessage msg) 
	{
		try
		{
			sOutput.writeObject(msg);
		}
		catch (NullPointerException e)
		{
			cg.append("","No help desk users available. Try again later ");
		}
		catch(IOException e) 
		{
			cg.append("","");
		}
	}
	private void disconnect() 
	{
		try 
		{ 
			if(sInput != null) sInput.close();
		}
		catch(Exception e) 
		{} // not much else I can do
		try 
		{
			if(sOutput != null) sOutput.close();
		}
		catch(Exception e) {} // not much else I can do
        try
        {
			if(socket != null) socket.close();
		}
		catch(Exception e) {} // not much else I can do
		if(cg != null)
			cg.connectionFailed();
	}
	public static ObjectInputStream getsInput() {
		return sInput;
	}
	public static void setsInput(ObjectInputStream sInput) {
		Anonymous.sInput = sInput;
	}
	public static ObjectOutputStream getsOutput() {
		return sOutput;
	}
	public static void setsOutput(ObjectOutputStream sOutput) {
		Anonymous.sOutput = sOutput;
	}
	public static AnonymousGUI getCg() {
		return cg;
	}
	public static void setCg(AnonymousGUI cg) {
		Anonymous.cg = cg;
	}
	
}