/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package Anonymous;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JScrollPane;

import Server.ChatMessage;


public class AnonymousGUI extends JFrame implements ActionListener, WindowListener 
{
	private static final long serialVersionUID = 8575079803260061574L;
	private boolean connected;
	private Anonymous anonymous;
	private JTextField server;
	private JTextField Port;
	private JTextField msgArea;
	private JTextArea chatArea;
	private JButton btnLogin, btnLogout, btnSend;
	private JComboBox destination;
	private JLabel source;
	private JScrollPane scrollPane;
	private static SimpleDateFormat sdf;
	public AnonymousGUI(String hostname, int port) 
	{
		super("Chat Client");
		getContentPane().setLayout(null);
		sdf = new SimpleDateFormat("HH:mm:ss");
		server = new JTextField();
		server.setBounds(93, 36, 114, 19);
		server.setText("localhost");
		getContentPane().add(server);
		server.setColumns(10);
		
		JLabel lblServer = new JLabel("Server: ");
		lblServer.setBounds(14, 38, 61, 15);
		getContentPane().add(lblServer);
		
		Port = new JTextField();
		Port.setBounds(332, 36, 114, 19);
		Port.setText("5000");
		getContentPane().add(Port);
		Port.setColumns(10);
		
		JLabel lblPort = new JLabel("Port:");
		lblPort.setBounds(231, 38, 61, 15);
		getContentPane().add(lblPort);
		
		btnLogin = new JButton("Login");
		btnLogin.setBounds(77, 422, 107, 25);
		btnLogin.addActionListener(this);
		getContentPane().add(btnLogin);
		
		btnLogout = new JButton("Logout");
		btnLogout.setBounds(185, 422, 107, 25);
		btnLogout.addActionListener(this);
		btnLogout.setEnabled(false);
		getContentPane().add(btnLogout);
		
		msgArea = new JTextField();
		msgArea.setBounds(77, 377, 215, 33);
		msgArea.setEditable(false);
		getContentPane().add(msgArea);
		msgArea.setColumns(10);
		
		btnSend = new JButton("Send");
		btnSend.setBounds(339, 381, 107, 25);
		btnSend.addActionListener(this);
		getContentPane().add(btnSend);
		
		destination = new JComboBox();
		destination.setBounds(231, 81, 114, 19);
		destination.setVisible(true);
		getContentPane().add(destination);
		
		source = new JLabel("New label");
		source.setBounds(348, 427, 61, 15);
		source.setVisible(false);
		getContentPane().add(source);
		
		scrollPane = new JScrollPane();
		scrollPane.setBounds(14, 112, 432, 253);
		getContentPane().add(scrollPane);
		
		chatArea = new JTextArea();
		scrollPane.setViewportView(chatArea);
		chatArea.setText("Welcome to the chat.\n");
		chatArea.setEditable(false);
		
		JLabel lblChattingWith = new JLabel("Chatting with:");
		lblChattingWith.setBounds(103, 72, 89, 33);
		getContentPane().add(lblChattingWith);
		addWindowListener(this);
		setSize(500, 500);
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
	void append(String flag,String string) 
	{
		String nxt = "";
		if (flag.equals("cgsendsserverfalse123456789"))
		{
			btnLogout.doClick();
			btnLogout.doClick();
	
			chatArea.append("No available HD users available.\n");
		}
		else
		{
			try
			{
				nxt = string.substring(string.indexOf(":") + 1, string.length());
				//nxt = nxt.substring(1,nxt.length());
				//System.out.println("this is the next hd user: " +  nxt);
				if (flag.equals("transfer123456789"))
				{
					destination.removeAllItems();
					destination.addItem(nxt);
					chatArea.append(sdf.format(new Date()) + " You are being transfered to: " + nxt + "\n");
				}
				else
				{
					if (string.contains("`") && !(string.contains("Anonymous")))
					{
						string = string.substring(0, string.length()-2);
	
						if (destination.getItemCount() != 1)
						{
							destination.addItem(string);
						}
					}
					else
					{
						if (!string.contains("`"))
						{
							chatArea.append(sdf.format(new Date()) + " "+string + "\n");
						}
					}
				}
			}
			catch (StringIndexOutOfBoundsException e) 
			{
				System.out.println("Can't append message to anonymous");
			}
		}
	}
	// called by the GUI is the connection failed
	// we reset our buttons, label, textfield
	void connectionFailed() 
	{
		btnLogin.setEnabled(true);
		btnLogout.setEnabled(false);
		this.Port.setText("5000");
		this.server.setText("localhost");
		this.server.setEditable(true);
		this.Port.setEditable(true);
		msgArea.removeActionListener(this);
		connected = false;
	}
	@Override
	public void actionPerformed(ActionEvent e) 
	{
		// TODO Auto-generated method stub
		Object o = e.getSource();
		// if it is the Logout button
		if(o == btnLogout) 
		{
			anonymous.sendMessage(new ChatMessage(ChatMessage.MESSAGE, " has logged out. `" + this.destination.getSelectedItem()));
			anonymous.sendMessage(new ChatMessage(ChatMessage.LOGOUT, ""));
	
			this.server.setEditable(true);
			this.Port.setEditable(true);

			this.chatArea.setText("");
			this.destination.removeAllItems();
			return;
		}
		if(o == btnLogin) 
		{
			source.setText("Anonymous");
			source.setVisible(false);
			String server = this.server.getText().trim();
			if(server.length() == 0)
				return;
			// empty or invalid port numer, ignore it
			String portNumber = this.Port.getText().trim();
			if(portNumber.length() == 0)
				return;
			int port = 0;
			try 
			{
				port = Integer.parseInt(portNumber);
			}
			catch(Exception en) 
			{
				return;   // nothing I can do if port number is not valid
			}
			// try creating a new Client with GUI
			anonymous = new Anonymous(server, port, "Anonymous", this);
			// test if we can start the Client
			connected = anonymous.start();
			if(!connected) 
			{
				System.out.println("can't connect");
				this.server.setEditable(true);
				this.Port.setEditable(true);
				return;
			}
			else
			{
				btnLogin.setEnabled(false);
				// enable the 2 buttons
				btnLogout.setEnabled(true);
				// disable the Server and Port JTextField
				this.server.setEditable(false);
				this.Port.setEditable(false);
				// Action listener for when the user enter a message
				msgArea.addActionListener(this);
				msgArea.setEditable(true);
				anonymous.sendMessage(new ChatMessage(ChatMessage.ONLINE,""));
			}
		}
		if (connected && o.equals(btnSend))
		{
			anonymous.sendMessage(new ChatMessage(ChatMessage.MESSAGE, msgArea.getText() + "`" + this.destination.getSelectedItem()));				
			System.out.println("message destination:" + this.destination.getSelectedItem());
			chatArea.append(sdf.format(new Date()) + " You sent: " + msgArea.getText() + "             \n              to             " + this.destination.getSelectedItem() +"\n");
			msgArea.setText("");
			msgArea.setEditable(true);
			return;
		}
	}
	public static void main(String[] args) 
	{
		new AnonymousGUI("localhost", 5000);
	}
	public void windowClosing(WindowEvent e) 
	{
		// if my Server exist
		btnLogout.doClick();
		//dispose();
		System.exit(0);
	}
	@Override
	public void windowActivated(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowClosed(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowDeactivated(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowDeiconified(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowIconified(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowOpened(WindowEvent e) {
		// TODO Auto-generated method stub
		
	}
}