/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package HelpDesk;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;

import Server.ChatMessage;


public class HelpDesk 
{
	private static ObjectInputStream sInput;		// to read from the socket
	public static ObjectOutputStream sOutput;		// to write on the socket
	private Socket socket;
	private static HelpDeskGUI hdg;
	
	private String server, username, password;
	private int port;
	
	public HelpDesk(String server, String username, String password, int port, HelpDeskGUI hdg)
	{
		this.server = server;
		this.username = username;
		this.password = password;
		this.port = port;
		HelpDesk.hdg = hdg;
	}
	public boolean start()
	{
		try
		{
			System.setProperty("javax.net.ssl.trustStore", "cacerts.jks");
			System.setProperty("javax.net.ssl.trustStorePassword","test123");
			SSLSocketFactory sslsocketfactory = (SSLSocketFactory)SSLSocketFactory.getDefault();
			socket = (SSLSocket)sslsocketfactory.createSocket(server,port);
		}
		catch (Exception e)
		{
			hdg.append("","Error connectiong to server:");
			return false;
		}
		String msg = "Connection accepted " + socket.getInetAddress() + ":" + socket.getPort();
		hdg.append("",msg);
		try
		{
			sInput  = new ObjectInputStream(socket.getInputStream());
			sOutput = new ObjectOutputStream(socket.getOutputStream());
		}
		catch(Exception e)
		{
			hdg.append("","Exception creating new Input/output Streams: " + e);
			return false;
		}
		
		new hdListener().start();
		try
		{
			sOutput.writeObject(username);
			sOutput.writeObject(password);
		}
		catch (IOException eIO) {
			hdg.append("","Exception doing login : " + eIO);
			disconnect();
			return false;
		}
		return true;
	}
	private void disconnect() 
	{
		// TODO Auto-generated method stub
		try 
		{ 
			if(sInput != null) sInput.close();
		}
		catch(Exception e) {} // not much else I can do
		try 
		{
			if(sOutput != null) sOutput.close();
		}
		catch(Exception e) {} // not much else I can do
        try
        {
			if(socket != null) socket.close();
		}
		catch(Exception e) {} // not much else I can do
		
		// inform the GUI
		if(hdg != null)
			hdg.connectionFailed();
	}
	void sendMessage(ChatMessage msg) 
	{
		try 
		{
			sOutput.writeObject(msg);
		}
		catch(IOException e) 
		{
			hdg.append("","Exception writing to server: " + e);
		}
	}
	public String toString()
	{
		return this.username + "\n";
	}
	public static ObjectInputStream getsInput() {
		return sInput;
	}
	public static void setsInput(ObjectInputStream sInput) {
		HelpDesk.sInput = sInput;
	}
	public static ObjectOutputStream getsOutput() {
		return sOutput;
	}
	public static void setsOutput(ObjectOutputStream sOutput) {
		HelpDesk.sOutput = sOutput;
	}
	public static HelpDeskGUI getHdg() {
		return hdg;
	}
	public static void setHdg(HelpDeskGUI hdg) {
		HelpDesk.hdg = hdg;
	}
	
}