/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package HelpDesk;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JFrame;
import javax.swing.JTextArea;

import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JPasswordField;

import Server.ChatMessage;


public class HelpDeskGUI extends JFrame implements ActionListener, WindowListener
{
	private static final long serialVersionUID = -463801827861432110L;
	private JTextField server;
	private JTextField port;
	private JTextField username;
	private JButton btnLogin;
	private JButton btnLogout;
	private JTextArea txtArea;
	private JComboBox OnlineClients;
	private boolean connected;
	private String host;
	private int portNumber;
	private HelpDesk hd;
	private JTextField msgArea;
	private JButton btnSend;
	private JButton btnOnline;
	private JPasswordField password;
	private JButton btnTransfer;
	private static SimpleDateFormat sdf;
	public HelpDeskGUI(String serverName, int portNumber) 
	{
		super("Help Desk Client");
		this.host = serverName;
		this.portNumber = portNumber;
		sdf = new SimpleDateFormat("HH:mm:ss");
		getContentPane().setLayout(null);
		
		JLabel label = new JLabel("Server");
		label.setBounds(12, 30, 61, 15);
		getContentPane().add(label);
		
		server = new JTextField();
		server.setText("localhost");
		server.setBounds(84, 28, 114, 19);
		getContentPane().add(server);
		server.setColumns(10);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(230, 30, 61, 15);
		getContentPane().add(lblPort);
		
		port = new JTextField("5000");
		port.setBounds(334, 28, 114, 19);
		getContentPane().add(port);
		port.setColumns(10);
		
		JLabel lblUsername = new JLabel("Username");
		lblUsername.setBounds(12, 62, 76, 27);
		getContentPane().add(lblUsername);
		
		username = new JTextField();
		username.setBounds(84, 66, 114, 19);
		getContentPane().add(username);
		username.setColumns(10);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(230, 68, 61, 15);
		getContentPane().add(lblPassword);
		
		btnLogin = new JButton("Login");
		btnLogin.setBounds(68, 439, 107, 25);
		getContentPane().add(btnLogin);
		btnLogin.addActionListener(this);
		
		btnLogout = new JButton("Logout");
		btnLogout.setBounds(230, 439, 102, 25);
		btnLogout.setEnabled(false);
		getContentPane().add(btnLogout);
		btnLogout.addActionListener(this);
		
		btnOnline = new JButton("Online Users");
		btnOnline.setEnabled(false);
		btnOnline.setVisible(true);
		btnOnline.setBounds(345 , 439 ,107 ,25);
		getContentPane().add(btnOnline);
		btnOnline.addActionListener(this);
		
		OnlineClients = new JComboBox();
		OnlineClients.setEditable(false);
		OnlineClients.setBounds(344, 121, 144, 59);
		getContentPane().add(OnlineClients);
		
		JLabel lblOnlineClients = new JLabel("Online Users");
		lblOnlineClients.setBounds(354, 100, 94, 21);
		getContentPane().add(lblOnlineClients);
		
		msgArea = new JTextField();
		msgArea.setBounds(12, 388, 211, 45);
		getContentPane().add(msgArea);
		msgArea.setColumns(10);
		//msgArea.setEnabled(false);
		
		btnSend = new JButton("Send");
		btnSend.setBounds(230, 388, 102, 45);
		getContentPane().add(btnSend);
		btnSend.addActionListener(this);
		btnSend.setEnabled(false);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(12, 101, 320, 275);
		getContentPane().add(scrollPane);
		
		txtArea = new JTextArea();
		scrollPane.setViewportView(txtArea);
		txtArea.setEditable(false);
		txtArea.setText("Welcome to the chat\n");
		txtArea.add(new JScrollPane());
		
		password = new JPasswordField();
		password.setBounds(334, 66, 114, 19);
		getContentPane().add(password);
		
		btnTransfer = new JButton("Transfer");
		btnTransfer.setEnabled(false);
		btnTransfer.setBounds(345, 398, 107, 25);
		btnTransfer.addActionListener(this);
		
		addWindowListener(this);
		getContentPane().add(btnTransfer);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setSize(500,500);
		setVisible(true);
	}
	@Override
	public void actionPerformed(ActionEvent e) 
	{
		// TODO Auto-generated method stub
		Object o = e.getSource();
		if (o.equals(btnLogin))
		{		
			
			String username = this.username.getText();
			String server = this.server.getText();
			if(server.length() == 0)
				return;
			String portNumber = this.port.getText();
			if(portNumber.length() == 0)
				return;
			int port = 0;
			try 
			{
				port = Integer.parseInt(portNumber);
			}
			catch(Exception en) 
			{
				return;   // nothing I can do if port number is not valid
			}
			String password = this.password.getText();
			if (password.length() == 0 || username.length() == 0)
			{
				txtArea.append(sdf.format(new Date()) + " Invalid username and password\n");
				return;
			}
			hd = new HelpDesk(server, username, password, port, this);
			// test if we can start the Client
			connected = hd.start();
			if(!connected) 
			{
				System.out.println("not connected");
				this.password.setText("");
				return;
			}
			else
			{
				msgArea.setEnabled(true);
				msgArea.setEditable(true);
				btnLogin.setEnabled(false);
				btnLogout.setEnabled(true);
				btnOnline.setEnabled(true);
				btnTransfer.setEnabled(true);				
				btnSend.setEnabled(true);
				this.password.setText("");
				hd.sendMessage(new ChatMessage(ChatMessage.ONLINE, ""));
				//send a message to all online help desk users to say we have just logged on
				for (int i = 0 ; i < OnlineClients.getItemCount();i++)
				{
					if (!(OnlineClients.getItemAt(i).toString().contains("Anonymous")))
					{
						hd.sendMessage(new ChatMessage(ChatMessage.MESSAGE,username + " has logged in" + "`" + OnlineClients.getItemAt(i)) );
					}
				}
			}
		}
		if (o.equals(btnLogout))
		{
			
			//System.out.println("logging out");
			OnlineClients.removeAllItems();
			this.server.setEditable(true);
			this.port.setEditable(true);
			for (int i = 0 ; i < OnlineClients.getItemCount();i++)
			{
				hd.sendMessage(new ChatMessage(ChatMessage.MESSAGE, " has logged out. `" + OnlineClients.getItemAt(i)));
			}
			hd.sendMessage(new ChatMessage(ChatMessage.LOGOUT, ""));
			connected = false;
			btnSend.setEnabled(false);
			btnOnline.setEnabled(false);
			btnTransfer.setEnabled(false);
			btnLogout.setEnabled(false);
			OnlineClients.removeAllItems();
			//hd.sendMessage(new ChatMessage(ChatMessage.ONLINE, ""));
			txtArea.setText("");
			//txtArea.setText("Succesfully logged out");
			System.out.println("finished logging out");
			OnlineClients.removeAllItems();
			connected = false;
			return;
		}
		if (connected && o.equals(btnSend))
		{
			//nobody to send the message to
			if (OnlineClients.getItemCount()== 0)
			{
				txtArea.append(sdf.format(new Date()) + " Nobody to send the message to.\n");
			}
			else
			{
				hd.sendMessage(new ChatMessage(ChatMessage.MESSAGE, msgArea.getText() + "`" +  OnlineClients.getSelectedItem()));		
				txtArea.append(sdf.format(new Date()) + " You sent: " + msgArea.getText() + "\n             to             " + OnlineClients.getSelectedItem() +"\n\n");
			}
				
			msgArea.setText("");
			msgArea.setEditable(true);
			return;
		}
		if (o.equals(btnOnline))
		{
			OnlineClients.removeAllItems();
			hd.sendMessage(new ChatMessage(ChatMessage.ONLINE, ""));		
		}
		if (o.equals(btnTransfer))
		{
			if (OnlineClients.getItemCount() == 0)
			{
				txtArea.append(sdf.format(new Date()) + " No one to transfer.\n");
			}	
			else if (!(OnlineClients.getSelectedItem().toString().contains("Anonymous")))
			{
				txtArea.append(sdf.format(new Date()) + " Can't transfer help desk users.\n");
			}
			else
			{
				hd.sendMessage(new ChatMessage(ChatMessage.TRANSFER,"`" + OnlineClients.getSelectedItem()));
			}
		}
	}
	public void append(String flag, String string) 
	{
		// TODO Auto-generated method stub
		
		//System.out.println("this is the msg: " + string);
		if (flag.equals("hdsendsserverfalse123456789") || flag.equals("usernamefalse123456789"))
		{
			//System.out.println("should be logging out now");
			btnLogout.doClick();
			btnLogout.doClick();
			//OnlineClients.removeAll();
			//txtArea.append(sdf.format(new Date()) + "Server has closed the connection. Logging out...");
		}
		else if (flag.equals("transfer123456789"))
		{
			String anon = string.substring(0,string.indexOf("`"));
			String dst = string.substring(string.indexOf(":"),string.length());
			txtArea.append(sdf.format(new Date()) + " Server transferring " + " " + anon + " to " + dst +"\n");
		}
		else
		{
			if (string.contains("`") && !(string.contains(this.username.getText())))
			{
				string = string.substring(0, string.length()-2);
				boolean found = false;
				OnlineClients.removeAll();
				for (int i =0; i < OnlineClients.getItemCount() && !found;i++)
				{
					if (OnlineClients.getItemAt(i).equals(string))
					{
						found = true;
					}
				}
				if (!found && connected)
				{
					System.out.println("adding ppl to client list");
					OnlineClients.addItem(string);
				}
			}
			else if ((!string.contains("`"))&& string.length()>0)
			{
				txtArea.append(sdf.format(new Date()) + " " + string + "\n");
			}
		}
	}
	public void connectionFailed() 
	{
		btnLogin.setEnabled(true);
		btnLogout.setEnabled(false);
		port.setText("" + 5000);
		server.setText("localhost");
		server.setEditable(true);
		port.setEditable(true);		
	}
	public static void main (String[] args)
	{
		new HelpDeskGUI("localhost", 5000);
	}
	@Override
	public void windowOpened(WindowEvent e) 
	{
		// TODO Auto-generated method stub
	}
	@Override
	public void windowClosing(WindowEvent e) 
	{
		btnLogout.doClick();
		System.exit(0);
	}
	@Override
	public void windowClosed(WindowEvent e) 
	{
		// TODO Auto-generated method stub		
	}
	@Override
	public void windowIconified(WindowEvent e) 
	{
		// TODO Auto-generated method stub
	}
	@Override
	public void windowDeiconified(WindowEvent e) 
	{
		// TODO Auto-generated method stub
	}
	@Override
	public void windowActivated(WindowEvent e) 
	{
		// TODO Auto-generated method stub		
	}
	@Override
	public void windowDeactivated(WindowEvent e)
	{
		// TODO Auto-generated method stub	
	}
}