/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package Server;
import java.io.*;
import java.net.*;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.CopyOnWriteArrayList;

import javax.net.ssl.SSLServerSocket;
import javax.net.ssl.SSLServerSocketFactory;
/*
 * The server that can be run both as a console application or a GUI
 */
public class Server 
{
	// a unique ID for each connection
	private static int uniqueID;
	// an ArrayList to keep the list of the Client
	static CopyOnWriteArrayList<UserThread> al;
	// if I am in a GUI
	private static ServerGUI sg;
	// to display time
	private static SimpleDateFormat sdf;
	// the port number to listen for connection
	private int port;
	// the boolean that will be turned of to stop the server
	private boolean keepGoing;
	private static CopyOnWriteArrayList<UserThread> hd; //data structure
	private Socket socket;
	private static HashMap<String, String> hdUsers = new HashMap<String, String>();
	public Server(int port) 
	{
		this(port, null);
	}
	
	public Server(int port, ServerGUI sg) 
	{
		Server.sg = sg;
		this.port = port;
		sdf = new SimpleDateFormat("HH:mm:ss");
		al = new CopyOnWriteArrayList<UserThread>();
		hd = new CopyOnWriteArrayList<UserThread>();
		try 
		{
			FileReader inputFile = new FileReader("hdFile.txt");
			BufferedReader br = new BufferedReader(inputFile);
			String line;
			while ((line = br.readLine()) != null)
			{
				String userName = line.substring(0,line.indexOf(":"));
				String pw = line.substring(line.indexOf(":")+1, line.length());
				hdUsers.put(userName,pw);
			}
		} 
		catch (FileNotFoundException e) 
		{
			// TODO Auto-generated catch block
			System.out.println("file somewhere else");
			e.printStackTrace();
		} 
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void start() 
	{
		keepGoing = true;
		try 
		{

			System.setProperty("javax.net.ssl.keyStore", "mySrvKeystore.jks");
			System.setProperty("javax.net.ssl.keyStorePassword","test123");
			SSLServerSocketFactory sslServerSocketfactory = (SSLServerSocketFactory)SSLServerSocketFactory.getDefault();
			SSLServerSocket serverSocket = (SSLServerSocket)sslServerSocketfactory.createServerSocket(port);
			
			// infinite loop to wait for connections
			while(keepGoing) 
			{
				// format message saying we are waiting
				//display(");
				String msg = sdf.format(new Date()) + "Server waiting for Clients on port " + port + ".";
				ServerGUI.appendEvent(msg);
				//Socket socket = serverSocket.accept();  	// accept connection
				socket = serverSocket.accept();
				
				// if I was asked to stop
				if(!keepGoing)
					break;
				
				UserThread t = new UserThread(socket);
						// save it in the ArrayList
				if (!t.username.equals("Anonymous"))
				{
					al.add(t);
					shift();
				}
					
				if (!(t.username.contains("Anonymous")))
				{
					boolean notIn = true;
					//check if username is logged in
					for (int i =0; i < hd.size() && notIn; i++)
					{
						UserThread temp = hd.get(i);
						if (temp.username.equals(t.username))
						{
							System.out.println("user already logged in\n");
							System.out.println(t.username);
							notIn = false;
						}
					}
					if (notIn)
						hd.add(t);								//add to help desk list
					else
					{
						System.out.println(t.username);
						broadcast("User is already logged in", t.username, null);
					}
				}
				t.start();
			}
			try 
			{
				socket.close();
				serverSocket.close();
				for(int i = 0; i < al.size(); ++i) 
				{
					UserThread tc = al.get(i);
					try 
					{
						tc.sInput.close();
						tc.sOutput.close();
						tc.socket.close();
					}
					catch(IOException ioE) 
					{
						// not much I can do
					}
				}
			}
			catch(Exception e) 
			{
				String time = sdf.format(new Date()) + "Exception closing the server and clients: " + e;
				ServerGUI.appendEvent(time + "\n");
			//	();
			}
		}
		catch (IOException e) 
		{
            String msg = sdf.format(new Date()) + " Exception on new ServerSocket: " + e + "\n";
			//display(msg);
            ServerGUI.appendEvent(msg);
		}
	}		
	protected void stop() 
	{
		keepGoing = false;

		try 
		{
			new Socket("localhost", port);
		}
		catch(Exception e) 
		{
			// nothing I can really do
		}
	}
	/*public static void display(String msg) 
	{
		String time = sdf.format(new Date()) + " " + msg;
		ServerGUI.appendEvent(time + "\n");
	}*/
	synchronized static void broadcast(String message, String destination, String source) 
	{
		if (message.equals("transfer123456789"))
		{		
			//System.out.println("transfering\n");
			boolean next = true;
			String nxtHD = "";
			for (int j = 0; j < hd.size() && next;j++)
			{
				UserThread ut = hd.get(j);
				if (!(ut.username.equals(source)))
				{
					nxtHD = ut.username;
					next = false;
				}
			}
			//System.out.println("nxt HD: " + nxtHD);
			if ((nxtHD.length() > 0)) //there's another person i can transfer to
			{
				for (int i = 0; i < al.size();++i)
				{
					UserThread ut = al.get(i);
					if (ut.username.equals(destination)|| ut.username.equals(nxtHD))
					{
						//System.out.println("userthread name: " + ut.username);
						//System.out.println("dst :" + destination);
						//System.out.println("src :" +source);
						if (!ut.writeMsg("transfer123456789",destination +"`:"+nxtHD))
						{
							//System.out.println("cant writing transfer msg");
							al.remove(i);
						//	display();
							String time = sdf.format(new Date()) + "Disconnected Client " + ut.username + " removed from list.";
							ServerGUI.appendEvent(time + "\n");
						}
						shift();
					}
					else if (ut.username.equals(source))
					{
						if (!ut.writeMsg("","You are transferring " + destination + " to " + nxtHD))
						{
							al.remove(i);
							//display();
							String time = sdf.format(new Date()) + "Disconnected Client " + ut.username + " removed from list.";
							ServerGUI.appendEvent(time + "\n");
						}
					}
				}
			}
		}
		else
		{
			//System.out.println("normal message\n");
			try
			{
				message = message.substring(0, message.indexOf("`"));
				String messageLf = message;
				// display message on console or GUI
				for(int i = 0; i < al.size();++i) 
				{
					UserThread ut = al.get(i);
					//System.out.println("ut thread name: " + ut.username + " dst: " + destination + "\n");
					//debugging
					boolean failed = false;
					for (int a =1;a <= ut.username.length() && !failed;a++)
					{
						String uN = ut.username.trim().substring(0,a);					
						String dst = destination.trim().substring(0,a);
						if (!uN.equals(dst))						
							failed = true;
					}
					if (!failed)
					{
						//System.out.println("found the destination\n");
						if(!ut.writeMsg("",source + ": " + messageLf + "\n            sent to            " + destination + "\n")) 
						{								
							al.remove(i);
							//display();
							String time = sdf.format(new Date()) + "Disconnected Client " + ut.username + " removed from list.";
							ServerGUI.appendEvent(time + "\n");
						}
						//display();
						String time = sdf.format(new Date()) + source + " sent " + message + " to " + destination;
						ServerGUI.appendEvent(time + "\n");
					}
				}	
			}
			catch (StringIndexOutOfBoundsException e)
			{}
		}
	}

	// for a user who logoff using the LOGOUT message
	synchronized static void remove(int id) 
	{
		// scan the array list until we found the Id
		for(int i = 0; i < al.size(); ++i) {
			UserThread ut = al.get(i);
			// found it
			if(ut.id == id) 
			{
				if (!(al.get(i).username.contains("Anonymous"))) //removing the help desk user
				{
					for (int j =0 ; j < hd.size();++j)
					{
						if (hd.get(j).id == id)
						{
							hd.remove(j);
						}
					}
				}
				al.remove(i);
				return;
			}
		}
		if (al.size() > 0)
			shift();
	}
	private static void shift()
	{
		UserThread temp = al.get(0);
		al.remove(0);
		al.add(temp);
	}

	public static int getUniqueID() {
		return uniqueID;
	}

	public static void setUniqueID(int uniqueID) {
		Server.uniqueID = uniqueID;
	}

	public static CopyOnWriteArrayList<UserThread> getAl() {
		return al;
	}

	public static void setAl(CopyOnWriteArrayList<UserThread> al) {
		Server.al = al;
	}

	public static ServerGUI getSg() {
		return sg;
	}

	public static void setSg(ServerGUI sg) {
		Server.sg = sg;
	}

	public static SimpleDateFormat getSdf() {
		return sdf;
	}

	public static void setSdf(SimpleDateFormat sdf) {
		Server.sdf = sdf;
	}

	public static CopyOnWriteArrayList<UserThread> getHd() {
		return hd;
	}

	public static void setHd(CopyOnWriteArrayList<UserThread> hd) {
		Server.hd = hd;
	}

	public static HashMap<String, String> getHdUsers() {
		return hdUsers;
	}

	public static void setHdUsers(HashMap<String, String> hdUsers) {
		Server.hdUsers = hdUsers;
	}
	
}
