/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package Server;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/*
 * The server as a GUI
 */
public class ServerGUI extends JFrame implements ActionListener, WindowListener
{

	private static final long serialVersionUID = 6715634239035949264L;
	// the stop and start buttons
	public static JButton stopStart;
	// JTextArea for the chat room and the events
	private static JTextArea event;
	// The port number
	public static JTextField tPortNumber;
	// my server
	public static Server server;
	// server constructor that receive the port to listen to for connection as parameter
	public ServerGUI(int port) 
	{
		super("Chat Server");
		server = null;
		// in the NorthPanel the PortNumber the Start and Stop buttons
		JPanel north = new JPanel();
		north.setBounds(0, 0, 398, 35);
		north.add(new JLabel("Port number: "));
		tPortNumber = new JTextField("  " + port);
		north.add(tPortNumber);
		// to stop or start the server, we start with "Start"
		stopStart = new JButton("Start");
		stopStart.addActionListener(this);
		getContentPane().setLayout(null);
		north.add(stopStart);
		getContentPane().add(north);

		JPanel center = new JPanel(new GridLayout(2,1));
		center.setBounds(0, 35, 386, 539);
		
		event = new JTextArea(80,80);
		event.setText("");
		event.setEditable(false);
		appendEvent("Events log.");
		center.add(new JScrollPane(event));	
		getContentPane().add(center);
		
		// need to be informed when the user click the close button on the frame
		addWindowListener(this);
		setSize(390, 330);
		setVisible(true);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}		
	public static void appendEvent(String str) 
	{
		event.append(str+"\n");
		event.setCaretPosition(event.getText().length() - 1);
	}
	// start or stop where clicked
	public void actionPerformed(ActionEvent e) 
	{
		// if running we have to stop
		if(server != null) 
		{
			server.stop();
			server = null;
			tPortNumber.setEditable(true);
			stopStart.setText("Start");
			return;
		}
      	// OK start the server	
		int port;
		try 
		{
			port = Integer.parseInt(tPortNumber.getText().trim());
		}
		catch(Exception er) {
			appendEvent("Invalid port number");
			return;
		}
		// ceate a new Server
		server = new Server(port, this);
		// and start it as a thread
		new ServerRunning().start();
		stopStart.setText("Stop");
		tPortNumber.setEditable(false);
	}
	
	// entry point to start the Server
	public static void main(String[] arg) 
	{
		// start server default port 1500
		new ServerGUI(5000);
	}
	@Override
	public void windowActivated(WindowEvent e) 
	{
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowClosed(WindowEvent e) 
	{
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowClosing(WindowEvent e) 
	{
		// TODO Auto-generated method stub
		if(server != null) 
		{
			try 
			{
				server.stop();			// ask the server to close the conection
			}
			catch(Exception eClose) {
			}
			server = null;
		}

		System.exit(0);
	}
	@Override
	public void windowDeactivated(WindowEvent e) 
	{
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowDeiconified(WindowEvent e)
	{
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowIconified(WindowEvent e)
	{
		// TODO Auto-generated method stub
		
	}
	@Override
	public void windowOpened(WindowEvent e)
	{
		// TODO Auto-generated method stub
		
	}
}