/*
 * A Simple Chat Program With Client/Server (GUI Optional)
 * pbl
 * December 13, 2011
 * Version 1.0
 * http://www.dreamincode.net/forums/topic/259777-a-simple-chat-program-with-clientserver-gui-optional/
 */
package Server;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.Date;

public class UserThread extends Thread 
{
		// the socket where to listen/talk
		Socket socket;
		public ObjectInputStream sInput;
		public ObjectOutputStream sOutput;
		int id;
		// the Username of the Client
		String username;
		// the only type of message a will receive
		ChatMessage cm;
		// the date I connect
		String date;
		String password;
		// Constructor
		UserThread(Socket socket) 
		{
			// a unique id
			id = Server.getUniqueID();
			id++;
			this.socket = socket;
			/* Creating both Data Stream */
			try
			{
				sOutput = new ObjectOutputStream(socket.getOutputStream());
				sInput  = new ObjectInputStream(socket.getInputStream());
				// read the username and password
				username = (String) sInput.readObject();
				password = (String) sInput.readObject();
				if (username.contains("Anonymous") && !(Server.getHd().isEmpty()))
				{
					username = username + id;
					String time = Server.getSdf().format(new Date()) + " " + username+" just connected";
					ServerGUI.appendEvent(time + "\n");
				}
				else if (!(username.contains("Anonymous"))) //HD user trying to login
				{
					if (Server.getHdUsers().containsKey(username) && Server.getHdUsers().get(username).equals(password))
					{
						boolean found = false;
						for (int i = 0; i < Server.getHd().size() && !found;i++)
						{
							if (Server.getHd().get(i).username.equals(username))
							{
								sOutput.writeObject("serverfalse123456789");
								found = true;
								ServerGUI.appendEvent(username + " is logged in but someone tried to login as well.\n");
							}		
						}
						String msg = Server.getSdf().format(new Date()) + " " + username + " just connected";
						ServerGUI.appendEvent(msg);
						
					}
					else
					{
						ServerGUI.appendEvent("Failed login attempt for: " + username);
						sOutput.writeObject("usernamefalse123456789");
					}
				}
				else //no help desk users to help clients so reject the connection
				{
					sOutput.writeObject("hdfalse1234567890");
					Server.remove(id);
					this.socket.close();
					close();
				}
			}
			catch (IOException e) 
			{
				String msg = Server.getSdf().format(new Date()) + " Exception creating new Input/output Streams: " + e;	
				ServerGUI.appendEvent(msg);
				return;
			}
			catch (ClassNotFoundException e) 
			{}
            date = new Date().toString() + "\n";

		}
		// what will run forever
		public void run() 
		{
			// to loop until LOGOUT
			boolean keepGoing = true;
			while(keepGoing) 
			{
				// read a String (which is an object)
				try 
				{
					cm = (ChatMessage) sInput.readObject();
				}
				catch (IOException e) 
				{
					String msg = Server.getSdf().format(new Date()) + " Exception reading streams: " + e;
					ServerGUI.appendEvent(msg);
					break;				
				}
				catch(ClassNotFoundException e2) 
				{
					break;
				}
				// the messaage part of the ChatMessage
				String message = cm.getMessage();
				// Switch on the type of message receive
				switch(cm.getType()) 
				{
					case ChatMessage.MESSAGE:
						String destination = message.substring(message.indexOf("`") +1, message.length());
						Server.broadcast(message, destination, username);
						break;
						
					case ChatMessage.LOGOUT:
						//Server.display(username + " disconnected with a LOGOUT message.");
						
						String msg = Server.getSdf().format(new Date()) + " " + username + " disconnected with a LOGOUT message";
						
						ServerGUI.appendEvent(msg);
						
						keepGoing = false;
						Server.remove(id);
						close();
						break;
						
					case ChatMessage.ONLINE:
	
						for(int i = 0; i < Server.al.size(); ++i) 
						{
							UserThread ut = Server.al.get(i);
							writeMsg("",ut.username + "` ");
						}
						break;
						
					case ChatMessage.TRANSFER:
						System.out.println("transfer message:" + message);
						String dst = message.substring(1, message.length());
						Server.broadcast("transfer123456789", dst, username);
						break;
				}
			}
		}
		// try to close everything
		private void close() 
		{
			// try to close the connection
			try 
			{
				if(sOutput != null) sOutput.close();
			}
			catch(Exception e) {}
			try {
				if(sInput != null) sInput.close();
			}
			catch(Exception e) {};
			try {
				if(socket != null) socket.close();
			}
			catch (Exception e) {}
		}
		/*
		 * Write a String to the Client output stream
		 */
		boolean writeMsg(String flag ,String msg) {
			// if Client is still connected send the message to it
			if(!socket.isConnected()) 
			{
				close();
				return false;
			}
			// write the message to the stream
			try 
			{
				sOutput.writeObject(flag);
				sOutput.writeObject(msg);
			}
			// if an error occurs, do not abort just inform the user
			catch(IOException e) 
			{
				String message = Server.getSdf().format(new Date()) + " Error sending message to" + username + e;
				ServerGUI.appendEvent(message);
			}
			return true;
		}
	}